#pragma once
#include <windows.h>


enum eControlConnectState : int
{
	RemoteConn_None = 0,
	RemoteConn_Connecting,
	RemoteConn_Connected,
};

enum eRunningMode : int
{
	RemoteNone = 0,
	VNCViewer = 1,
	VNCServer = 2,
	FileTransfer = 4, 
};

typedef int (__stdcall *FnInitEngine)(const wchar_t* authKey);
typedef int (__stdcall *FnInitRemoteInfo)(const wchar_t* identifier, const int asDriver, const wchar_t* serverAddr, const int serverPort, void* pFuncNotice, void* pObjPoint);
typedef int (__stdcall *FnSetProxy)(const int proxyType, const wchar_t* proxyServer, const int proxyPort, const wchar_t* proxyUser, const wchar_t* proxyPwd, const wchar_t* proxyDomain);
typedef int (__stdcall *FnStartRemote)(const wchar_t* identifier, int isViewer, int isControl, int quality, const wchar_t* myName, const wchar_t* peerName);
typedef int (__stdcall *FnStopRemote)(const wchar_t* identifier);
typedef int (__stdcall *FnSetParam)(const wchar_t* identifier, const int paramFlag, UINT_PTR paramValue);
typedef int (__stdcall *FnGetStatus)(const wchar_t* identifier);
typedef int (__stdcall *FnDisConnect)(const wchar_t* identifier);

class NiuniuRemoteWrapper
{

protected:
	NiuniuRemoteWrapper(void);
	virtual ~NiuniuRemoteWrapper(void);
public:
	static void Init();
	static int InitEngine(const wchar_t* authKey);
	static int InitRemoteInfo(const wchar_t* identifier, const int asDriver, const wchar_t* serverAddr, const int serverPort, void* pFuncNotice, void* pObjPoint);
	static int SetProxy(const int identifier, const wchar_t* proxyServer, const int proxyPort, const wchar_t* proxyUser, const wchar_t* proxyPwd, const wchar_t* proxyDomain);
	static int StartRemote(const wchar_t* identifier, int isViewer, int isControl, int quality, const wchar_t* myName, const wchar_t* peerName);
	static int StopRemote(const wchar_t* identifier);
	static int SetParam(const wchar_t* identifier, const int paramFlag, UINT_PTR paramValue);
	static int GetStatus(const wchar_t* identifier);
	static int DisConnect(const wchar_t* identifier);
private:
	static HMODULE m_hModule;
	static FnInitEngine			s_InitEngine;
	static FnInitRemoteInfo		s_InitRemoteInfo;
	static FnSetProxy			s_SetProxy;	
	static FnStartRemote		s_StartRemote;
	static FnStopRemote			s_StopRemote;
	static FnSetParam			s_SetParam;
	static FnGetStatus			s_GetStatus;
	static FnDisConnect			s_DisConnect;
};